--[[
	Persistent Data for RaidTracker, Saved Variables	
]]


--***********************************************************************************
-- Saved Variables

KA_RaidTracker_Online = { };

KA_RaidTracker_Options = 
{
    ["AutoRaidCreation"] = 1,           -- on/off
    ["AutoBoss"] = 1,                   -- 0,1,2
    ["AutoBossBoss"] = "Trash mob",     -- just the name of the boss
    ["AutoZone"] = 1,                   -- on/off
    ["AskCost"] = 0,                    -- 1:poor, 2:common, 3:uncommon, 4:rare, 5:epic, 6:legendary, 7:artifact, asks for cost for items with at least this rarity
    ["MinQuality"] = 3,                 -- 1:poor, 2:common, 3:uncommon, 4:rare, 5:epic, 6:legendary, 7:artifact
    ["GroupItems"] = 0,                 -- 1:poor, 2:common, 3:uncommon, 4:rare, 5:epic, 6:legendary, 7:artifact
    ["GetDkpValue"] = 0,                -- 1:poor, 2:common, 3:uncommon, 4:rare, 5:epic, 6:legendary, 7:artifact
    ["Timezone"] = 0,
    ["TimeSync"] = 1,
    ["DebugFlag"] = nil,                -- on/off
    ["LogAttendees"] = 0,               -- 0:off, 1:for each looted item, 2:for each bosskill
    ["SaveExtendedPlayerInfo"] = 1,     -- on/off - save race, class and level  
    ["SaveTooltips"] = 1,               -- on/off - save tooltips of items
    ["24hFormat"] = 1,                  -- on/off - Use 24h time format
    ["AutoBossChangeMinTime"] = 120,    -- how long should trash mob's ignored after a boss kill (seconds)?
    ["Wipe"] = 0,                       -- ask if the group dies if it is a wipe, if all are dead it will not ask
    ["WipePercent"] = 0.5,              -- how many prozent of group must be dead to ask
    ["WipeCoolDown"] = 120,             -- how long should death be ignored after a wipe count (seconds)
    ["NextBoss"] = 0,                   -- ask on boss kill whats the next boss is
    ["MaxLevel"] = 70,                  -- If player lvl is maxlevel it will not be exported to mldkp
    ["GuildSnapshot"] = 0,              -- Snapshots the guildroster on bosskill
    ["ExportFormat"] = 2,               -- ExportFormat for the xml string

    -- ML_RaidTracker_Custom_Options
    ["LogGroup"] = 1,
    ["GuildSnapshot"] = 0,
    ["AutoGroup"] = 1,
    ["LogBattlefield"] = 0,
    ["OldFormat"] = 1,
    ["MLdkp"] = 1,
    
    -- Internal flags
    ["VersionFix"] = 0,                 -- Flag to determine current database version for saved variables
    ["VersionCopy"] = 0,                -- Flag to determine current database version for saved variables
	["TimeOffsetStatus"] = 0,           -- ???
	["ItemOptionsSelected"] = nil,		-- ???
};

KA_RaidTracker_SortOptions = {
    ["method"] = "name",
    ["way"] = "asc",
    ["itemmethod"] = "looted",
    ["itemway"] = "asc",
    ["itemfilter"] = 1,
    ["playerraidway"] = "desc",
    ["playeritemfilter"] = 1,
    ["playeritemmethod"] = "name",
    ["playeritemway"] = "asc",
    ["itemhistorymethod"] = "name",
    ["itemhistoryway"] = "asc"
};

KA_RaidTracker_ItemOptions = {};

KA_RaidTracker_GetCurrentRaid = nil;

KA_RaidTracker_CustomZoneTriggers = {};

KA_RaidTracker_RaidLog = { };

--***********************************************************************************
-- Data Converter for old versions

function KA_RaidTracker_RunVersionFix()
	local debugflagpre = KA_RaidTracker_Options["DebugFlag"];
	--KA_RaidTracker_Options["DebugFlag"] = 1;
    
    -- copy old db
    if(KA_RaidTracker_Options["VersionCopy"] == 0) then
	    if(KA_RaidTracker_Online) then
	        KA_RaidTracker_Online = KA_RaidTracker_Online;
	    end
	    if(KA_RaidTracker_Options) then
	        KA_RaidTracker_Options = KA_RaidTracker_Options;
	    end
	    if(KA_RaidTracker_SortOptions) then
	        KA_RaidTracker_SortOptions = KA_RaidTracker_SortOptions;
	    end
	    if(KA_RaidTracker_ItemOptions) then
	        KA_RaidTracker_ItemOptions = KA_RaidTracker_ItemOptions;
	    end
	   if(KA_RaidTracker_GetCurrentRaid) then
	        KA_RaidTracker_GetCurrentRaid = KA_RaidTracker_GetCurrentRaid;
	    end
	   if(KA_RaidTracker_CustomZoneTriggers) then
	        KA_RaidTracker_CustomZoneTriggers = KA_RaidTracker_CustomZoneTriggers;
	    end
	   if(KA_RaidTracker_RaidLog) then
	        KA_RaidTracker_RaidLog = KA_RaidTracker_RaidLog;
	    end
        KA_RaidTracker_Options["VersionCopy"] = 1;
    end
    
	if(KA_RaidTracker_Options["VersionFix"] == 0) then
		KA_RaidTracker_Debug("VersionFix", 1);
		for k, v in pairs(KA_RaidTracker_RaidLog) do
			if(not KA_RaidTracker_RaidLog[k]["PlayerInfos"]) then
				KA_RaidTracker_RaidLog[k]["PlayerInfos"] = { };
			end
			if ( v["Notes"] ) then
				for notesk, notesv in pairs(v["Notes"]) do
					if(not KA_RaidTracker_RaidLog[k]["PlayerInfos"][notesk]) then
						KA_RaidTracker_RaidLog[k]["PlayerInfos"][notesk] = { };
					end
					KA_RaidTracker_RaidLog[k]["PlayerInfos"][notesk]["note"] = notesv;
					KA_RaidTracker_Debug("VersionFix", 1, "note", k, notesk, notesv);
				end
				KA_RaidTracker_RaidLog[k]["Notes"] = nil;
			end
		end
		KA_RaidTracker_Options["VersionFix"] = 1;
	end
	if(KA_RaidTracker_Options["VersionFix"] == 1) then
		KA_RaidTracker_Debug("VersionFix", 2);
		KA_RaidTracker_Options["VersionFix"] = 2; -- Do not remove tooltips any longer
	end
	if(KA_RaidTracker_Options["VersionFix"] == 2) then
		KA_RaidTracker_Debug("VersionFix", 3);
		if(KA_RaidTracker_MinQuality) then KA_RaidTracker_Options["MinQuality"] = KA_RaidTracker_MinQuality; KA_RaidTracker_Debug("VersionFix", 3, "KA_RaidTracker_MinQuality", KA_RaidTracker_MinQuality); end
		if(KA_RaidTracker_AutoRaidCreation) then KA_RaidTracker_Options["AutoRaidCreation"] = KA_RaidTracker_AutoRaidCreation; KA_RaidTracker_Debug("VersionFix", 3, "KA_RaidTracker_AutoRaidCreation", KA_RaidTracker_AutoRaidCreation); end
		if(KA_RaidTracker_GroupItems) then KA_RaidTracker_Options["GroupItems"] = KA_RaidTracker_GroupItems; KA_RaidTracker_Debug("VersionFix", 3, "KA_RaidTracker_GroupItems", KA_RaidTracker_GroupItems); end
		if(KA_RaidTracker_GetDkpValue) then KA_RaidTracker_Options["GetDkpValue"] = KA_RaidTracker_GetDkpValue; KA_RaidTracker_Debug("VersionFix", 3, "KA_RaidTracker_GetDkpValue", KA_RaidTracker_GetDkpValue); end
		if(KA_RaidTracker_OldFormat) then KA_RaidTracker_Options["OldFormat"] = KA_RaidTracker_OldFormat; KA_RaidTracker_Debug("VersionFix", 3, "KA_RaidTracker_OldFormat", KA_RaidTracker_OldFormat); end
		if(KA_RaidTracker_AutoBoss) then KA_RaidTracker_Options["AutoBoss"] = KA_RaidTracker_AutoBoss; KA_RaidTracker_Debug("VersionFix", 3, "KA_RaidTracker_AutoBoss", KA_RaidTracker_AutoBoss); end
		if(KA_RaidTracker_AutoBossBoss) then KA_RaidTracker_Options["AutoBossBoss"] = KA_RaidTracker_AutoBossBoss; KA_RaidTracker_Debug("VersionFix", 3, "KA_RaidTracker_AutoBossBoss", KA_RaidTracker_AutoBossBoss); end
		if(KA_RaidTracker_AutoZone) then KA_RaidTracker_Options["AutoZone"] = KA_RaidTracker_AutoZone; KA_RaidTracker_Debug("VersionFix", 3, "KA_RaidTracker_AutoZone", KA_RaidTracker_AutoZone); end
		if(KA_RaidTracker_AskCosts) then KA_RaidTracker_Options["AskCost"] = KA_RaidTracker_AskCosts; KA_RaidTracker_Debug("VersionFix", 3, "KA_RaidTracker_AskCosts", KA_RaidTracker_AskCosts); end
		if(KA_RaidTracker_Timezone) then KA_RaidTracker_Options["Timezone"] = KA_RaidTracker_Timezone; KA_RaidTracker_Debug("VersionFix", 3, "KA_RaidTracker_Timezone", KA_RaidTracker_Timezone); end
		if(KA_RaidTracker_TimeSync) then KA_RaidTracker_Options["TimeSync"] = KA_RaidTracker_TimeSync; KA_RaidTracker_Debug("VersionFix", 3, "KA_RaidTracker_TimeSync", KA_RaidTracker_TimeSync); end
		if(KA_RaidTracker_DebugFlag) then KA_RaidTracker_Options["DebugFlag"] = KA_RaidTracker_DebugFlag; KA_RaidTracker_Debug("VersionFix", 3, "KA_RaidTracker_DebugFlag", KA_RaidTracker_DebugFlag); end
		
		for k, v in pairs(KA_RaidTracker_RaidLog) do
			if(KA_RaidTracker_RaidLog[k]["BossKills"] and getn(KA_RaidTracker_RaidLog[k]["BossKills"]) >= 1 and not KA_RaidTracker_RaidLog[k]["BossKills"][1]) then
				local tempbosskills = {};
				for k2, v2 in pairs(KA_RaidTracker_RaidLog[k]["BossKills"]) do
					tempbosskills[k2] = v2;
				end
				KA_RaidTracker_RaidLog[k]["BossKills"] = {};
				for k2, v2 in pairs(tempbosskills) do
					tinsert(KA_RaidTracker_RaidLog[k]["BossKills"],
						{
							["boss"] = k2,
							["time"] = v2,
							["attendees"] = {}
						}
					);
					KA_RaidTracker_Debug("VersionFix", 3, "BossKills", k, k2);
				end
			end
		end
		KA_RaidTracker_Options["VersionFix"] = 3;
	end
	if(KA_RaidTracker_Options["VersionFix"] == 3) then
		KA_RaidTracker_Debug("VersionFix", 4);
		for k, v in pairs(KA_RaidTracker_RaidLog) do
			if(KA_RaidTracker_RaidLog[k]["BossKills"]) then
				for k2, v2 in pairs(KA_RaidTracker_RaidLog[k]["BossKills"]) do
					if(type(v2["time"]) == "table") then
						KA_RaidTracker_Debug("VersionFix", 4, "BossKills Fix", k, k2, v2["time"]["boss"], v2["time"]["time"]);
						KA_RaidTracker_RaidLog[k]["BossKills"][k2]["boss"] = v2["time"]["boss"];
						KA_RaidTracker_RaidLog[k]["BossKills"][k2]["attendees"] = v2["time"]["attendees"];
						KA_RaidTracker_RaidLog[k]["BossKills"][k2]["time"] = v2["time"]["time"];
					end
				end
			end
		end
		KA_RaidTracker_Options["VersionFix"] = 4;
	end
	if(KA_RaidTracker_Options["VersionFix"] == 4) then
		KA_RaidTracker_Options["Wipe"] = 1;  							-- ask if the group dies if it is a wipe, if all are dead it will not ask
		KA_RaidTracker_Options["WipePercent"] = 0.5;    		-- how many prozent of group must be dead to ask
    KA_RaidTracker_Options["WipeCoolDown"] = 150;			-- how long should death be ignored after a wipe count (seconds)
		KA_RaidTracker_Options["NextBoss"] = 1;  				-- ask on boss kill whats the next boss is
		
		KA_RaidTracker_Options["VersionFix"] = 5;
	end
	if (KA_RaidTracker_Options["VersionFix"] == 5) then
		KA_RaidTracker_Options["MaxLevel"] = 70;  -- If player lvl is maxlevel it will not be exported to mldkp
		KA_RaidTracker_Options["MLdkp"] = 1; 			-- Export für mldkp
		KA_RaidTracker_Options["GuildSnapshot"] = 0; -- Snapshots the guildroster on bosskill
		
		KA_RaidTracker_Options["VersionFix"] = 6;
	end;
	if (KA_RaidTracker_Options["VersionFix"] == 6) then
		if (KA_RaidTracker_Options["MLdkp"] and KA_RaidTracker_Options["MLdkp"] == 1) then
			KA_RaidTracker_Options["ExportFormat"] = 2;
		else
			if (KA_RaidTracker_Options["OldFormat"] and KA_RaidTracker_Options["OldFormat"] == 1) then
				KA_RaidTracker_Options["ExportFormat"] = 0;
			else
				KA_RaidTracker_Options["ExportFormat"] = 1;
			end;
		end;
		KA_RaidTracker_Options["MLdkp"] = nil;
		KA_RaidTracker_Options["OldFormat"] = nil;
		KA_RaidTracker_Options["VersionFix"] = 7;
		KA_RaidTrackerOptionsFrame:Show();
	end;
	  
	KA_RaidTracker_Options["DebugFlag"] = debugflagpre;
end
